'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _reactAddons = require('react/addons');

var _reactAddons2 = _interopRequireDefault(_reactAddons);

var _EditorLineContent = require('./EditorLineContent');

var _EditorLineContent2 = _interopRequireDefault(_EditorLineContent);

var _SelectionOverlay = require('./SelectionOverlay');

var _SelectionOverlay2 = _interopRequireDefault(_SelectionOverlay);

var _coreEditorCommon = require('../core/EditorCommon');

var _coreReactUtils = require('../core/ReactUtils');

var _coreReactUtils2 = _interopRequireDefault(_coreReactUtils);

var T = _reactAddons2['default'].PropTypes;

exports['default'] = _reactAddons2['default'].createClass({
  displayName: 'EditorLine',

  propTypes: {
    line: T.object,
    lineHeight: T.number.isRequired,
    fontSize: T.number.isRequired,
    selection: T.object,
    remoteSelections: T.arrayOf(T.object)
  },

  shouldComponentUpdate: function shouldComponentUpdate(nextProps) {
    // for better performance make sure objects are immutable so that we can do reference equality checks
    var propsEqual = this.props.lineHeight === nextProps.lineHeight && this.props.fontSize === nextProps.fontSize && _coreReactUtils2['default'].deepEquals(this.props.selection, nextProps.selection) && _coreReactUtils2['default'].deepEquals(this.props.remoteSelections, nextProps.remoteSelections) && _coreReactUtils2['default'].deepEquals(this.props.line, nextProps.line, _coreEditorCommon.linesEq);

    return !propsEqual;
  },

  _renderSelectionOverlay: function _renderSelectionOverlay(selection) {
    if (!selection) {
      return null;
    }
    return _reactAddons2['default'].createElement(_SelectionOverlay2['default'], { key: selection && selection.color ? selection.color : 'local', selection: selection });
  },

  _renderRemoteSelectionOverlays: function _renderRemoteSelectionOverlays(remoteSelections) {
    var _this = this;

    if (!remoteSelections) {
      return null;
    }
    return remoteSelections.map(function (s) {
      return _this._renderSelectionOverlay(s);
    });
  },

  render: function render() {
    //console.trace('render EditorLine')
    return _reactAddons2['default'].createElement(
      'div',
      { className: 'ritzy-internal-text-lineview text-lineview', style: { height: this.props.lineHeight, direction: 'ltr', textAlign: 'left' } },
      this._renderSelectionOverlay(this.props.selection),
      this._renderRemoteSelectionOverlays(this.props.remoteSelections),
      _reactAddons2['default'].createElement(_EditorLineContent2['default'], { fontSize: this.props.fontSize, line: this.props.line })
    );
  }

});
module.exports = exports['default'];