'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _reactAddons = require('react/addons');

var _reactAddons2 = _interopRequireDefault(_reactAddons);

var _coreReactUtils = require('../core/ReactUtils');

var _coreReactUtils2 = _interopRequireDefault(_coreReactUtils);

var T = _reactAddons2['default'].PropTypes;

exports['default'] = _reactAddons2['default'].createClass({
  displayName: 'SelectionOverlay',

  propTypes: {
    selection: T.object
  },

  shouldComponentUpdate: function shouldComponentUpdate(nextProps) {
    // for better performance make sure objects are immutable so that we can do reference equality checks
    var propsEqual = _coreReactUtils2['default'].deepEquals(this.props.selection, nextProps.selection);
    return !propsEqual;
  },

  render: function render() {
    //console.trace('render SelectionOverlay')
    var selection = this.props.selection;
    if (!selection) {
      return null;
    }

    var selectionStyle = {
      top: 0,
      left: selection.left,
      width: selection.width,
      height: selection.height
    };

    if (selection.color) {
      selectionStyle.borderTopColor = selection.color;
      selectionStyle.borderBottomColor = selection.color;
      selectionStyle.backgroundColor = selection.color;
      selectionStyle.opacity = 0.15;
      selectionStyle.color = selection.color;
    }

    return _reactAddons2['default'].createElement('div', { className: 'ritzy-internal-text-selection-overlay text-selection-overlay ritzy-internal-text-htmloverlay ritzy-internal-text-htmloverlay-under-text ritzy-internal-ui-unprintable',
      style: selectionStyle });
  }

});
module.exports = exports['default'];