'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function deepEquals(obj1, obj2, equalsFunc, propertyAccessors) {
  if (!obj1) {
    return Object.is(obj1, obj2);
  }

  if (!equalsFunc) {
    equalsFunc = _lodash2['default'].isEqual;
  }

  if (propertyAccessors) {
    for (var i = 0; i < propertyAccessors.length; i++) {
      var f = propertyAccessors[i];
      if (!equalsFunc(f(obj1), f(obj2))) return false;
    }
    return true;
  } else {
    return equalsFunc(obj1, obj2);
  }
}

exports['default'] = {
  deepEquals: deepEquals
};
module.exports = exports['default'];